﻿local LFM = LFMonitor
LFM.frame:RegisterEvent("ADDON_LOADED")
LFM.frame:RegisterEvent("PLAYER_LOGIN")
LFM.frame:SetScript("OnEvent", function(...) LFM:OnEvent(...) end)
LFM.frame.flashtimer = 0
LFM.TimeSinceLastUpdate = 0
LFM.LFM_Update_Int = 20.0
LFM.CL_Update_Int = 0.5
LFM.testmode = false
LFM.history = {}
LFM.hindex = 1
LFM.TFW_PATTERN = "^_$(%d+)(.+)_$(.+)_$(.+)%$$"
LFM.LS = LibStub
LFM.CTL = ChatThrottleLib
LFM.L = LFM.LS("AceLocale-3.0"):GetLocale("LFMonitor")
local L = LFM.L
local strsplit = strsplit

LFM.jctxt = {strsplit(",", L["jc_search_terms"])}
LFM.enctxt = {strsplit(",", L["enc_search_terms"])}
LFM.lwtxt = {strsplit(",", L["lw_search_terms"])}
LFM.instxt = {strsplit(",", L["ins_search_terms"])}
LFM.tlrtxt = {strsplit(",", L["tlr_search_terms"])}
LFM.bstxt = {strsplit(",", L["bs_search_terms"])}
LFM.alctxt = {strsplit(",", L["alc_search_terms"])}
LFM.engtxt = {strsplit(",", L["eng_search_terms"])}
LFM.wtbtxt = {strsplit(",", L["wtb_search_terms"])}
LFM.wtstxt = {strsplit(",", L["wts_search_terms"])}
LFM.lftxt = {strsplit(",", L["lf_search_terms"])}
LFM.misctxt = {strsplit(",", L["misc_search_terms"])}
LFM.lfwtxt = {strsplit(",", L["lfw_search_terms"])}
LFM.lfmtxt = {strsplit(",", L["lfm_search_terms"])}
LFM.lfgtxt = {strsplit(",", L["lfg_search_terms"])}
LFM.DK_TXT = {strsplit(",", L["deathknight_search_terms"])}
LFM.DR_TXT = {strsplit(",", L["druid_search_terms"])}
LFM.HU_TXT = {strsplit(",", L["hunter_search_terms"])}
LFM.MA_TXT = {strsplit(",", L["mage_search_terms"])}
LFM.MO_TXT = {strsplit(",", L["monk_search_terms"])}
LFM.PA_TXT = {strsplit(",", L["paladin_search_terms"])}
LFM.PR_TXT = {strsplit(",", L["priest_search_terms"])}
LFM.RO_TXT = {strsplit(",", L["rogue_search_terms"])}
LFM.SH_TXT = {strsplit(",", L["shaman_search_terms"])}
LFM.WA_TXT = {strsplit(",", L["warlock_search_terms"])}
LFM.WR_TXT = {strsplit(",", L["warrior_search_terms"])}
LFM.TANK_TXT = {strsplit(",", L["tank_search_terms"])}
LFM.HEALER_TXT = {strsplit(",", L["healer_search_terms"])}
LFM.DPS_TXT = {strsplit(",", L["dps_search_terms"])}
LFM.CC_TXT = {strsplit(",", L["cc_search_terms"])}
LFM.MELEE_TXT = {strsplit(",", L["melee_search_terms"])}
LFM.RANGED_TXT = {strsplit(",", L["ranged_search_terms"])}
LFM.ALL_TXT = {strsplit(",", L["all_search_terms"])}

LFM.sounds = {
	[1] = {
		file = "LOOTWINDOWCOINSOUND",
		name = LFM.COINS,
		type = "game"
	},
	[2] = {
		file = "INTERFACESOUND_CHARWINDOWTAB",
		name = LFM.WINDOW_TAB,
		type = "game"
	},
	[3] = {
		file = "INTERFACESOUND_GAMEMENUOPEN",
		name = LFM.MENU_OPENING,
		type = "game"
	},
	[4] = {
		file = "igMiniMapOpen",
		name = LFM.MINIMAP_OPENING,
		type = "game"
	},
	[5] = {
		file = "igSpellBookOpen",
		name = LFM.SPELLBOOK_OPENING,
		type = "game"
	},
	[6] = {
		file = "igSpellBookClose",
		name = LFM.SPELLBOOK_CLOSING,
		type = "game"
	},
	[7] = {
		file = "TalentScreenOpen",
		name = LFM.TALENTS_OPENING,
		type = "game"
	},
	[8] = {
		file = "igQuestLogOpen",
		name = LFM.QUEST_LOG_OPENING,
		type = "game"
	},
	[9] = {
		file = "Fishing Reel in",
		name = LFM.FISHING,
		type = "game"
	},
	[10]= {
		file = "HumanExploration",
		name = LFM.DISCOVERY,
		type = "game"
	},
	[11]= {
		file = "applause.ogg",
		name = LFM.APPLAUSE,
		type = "addon"
	},
	[12]= {
		file = "BEEPMULT.ogg",
		name = LFM.BEEP,
		type = "addon"
	},
	[13]= {
		file = "CLICK10B.ogg",
		name = LFM.CLICK,
		type = "addon"
	},
	[14]= {
		file = "dogbrk.ogg",
		name = LFM.DOG_BARKING,
		type = "addon"
	},
	[15]= {
		file = "pcmouseclick1.ogg",
		name = LFM.MOUSE_CLICK,
		type = "addon"
	},
	[16]= {
		file = "stapler2.ogg",
		name = LFM.STAPLER,
		type = "addon"
	}
}

LFM.fonts = {
	[1] = {
		file = "Fonts\\FRIZQT__.TTF",
		name = LFM.FONT_FRIZ
	},
	[2] = {
		file = "Fonts\\ARIALN.TTF",
		name = LFM.FONT_ARIALN
	},
	[3] = {
		file = "Fonts\\skurri.ttf",
		name = LFM.FONT_SKURRI
	},
	[4] = {
		file = "Fonts\\MORPHEUS.ttf",
		name = LFM.FONT_MORPHEUS
	}
}

LFM.timestamps = {
	[1] = {
		name = LFM.TS_12HR1,
		format = "%I:%M"
	},
	[2] = {
		name = LFM.TS_12HR2,
		format = "%I:%M:%S"
	},
	[3] = {
		name = LFM.TS_12HR3,
		format = "%I:%M %p"
	},
	[4] = {
		name = LFM.TS_12HR4,
		format = "%I:%M:%S %p"
	},
	[5] = {
		name = LFM.TS_24HR1,
		format = "%H:%M"
	},
	[6] = {
		name = LFM.TS_24HR2,
		format = "%H:%M:%S"
	}
}

LFM.defaults = {
	char = {
		professions = {jc = false, enc = false, lw = false, ins = false, tlr = false, bs = false, alc = false, eng = false },
		monitoring = {lf = false, wtb = false, lfm = false, lfg = false, misc = false, lfw = false, wts = false},
		responses = {jc = LFM.WHISPER_ME, enc = LFM.WHISPER_ME, lw = LFM.WHISPER_ME, ins = LFM.WHISPER_ME, tlr = LFM.WHISPER_ME,
			bs = LFM.WHISPER_ME, alc = LFM.WHISPER_ME, eng = LFM.WHISPER_ME, lfg = LFM.LFG_RESPONSE},
		classes = {dk = false, dr = false, hu = false, ma = false, mo = false, pa = false, pr = false, ro = false, sh = false, wa = false, wr = false},
		channels = {general = true, trade = true, guild = false},
		raids = {},
	},
	profile = {
		options = {scl = true, hinst = true, rested = false, combat = false, soundon = true, sound = 15,
			locked = false, disabled = false, trade = true, timestamp = 5, basic = "", adv = "", basicesc = "",
			useclasscolours = false, overrideraid = false},
		alert = {
			font = {index = 1, height = 14, timestamp = "ffffd200", player = "ff22ee55", text = "ffffffff"},
			backdrop = {background = "80000000", border = "ff87bdff"},
			position = {x = -1, y = -1, width = 575, height = 100},
		},
	}
}

-- Popup dialogues
StaticPopupDialogs["LFM_NOAUTOREPLY"] = {
	text = LFM.CANNOT_SEND,
	button1 = _G.OKAY,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}

StaticPopupDialogs["LFM_DEFAULTS"] = {
	text = LFM.RESET_CONFIRM,
	button1 = _G.YES,
	button2 = _G.NO,
	OnAccept = function() LFM:ResponseOptionsDefault() end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}

--no operation used for certain request types
LFM.nop = {""}