﻿local LFM = LFMonitor
local _G = _G
local AceConfig = LFM.LS("AceConfig-3.0")
local AceConfigDialog = LFM.LS("AceConfigDialog-3.0")
local AceDBOptions = LFM.LS("AceDBOptions-3.0")
local L = LFM.L

--[[
function LFMonitor:CustomOptionsOkay()

	local bas = _G.LFMonitorBasicEdit:GetText() or ""
	local adv = _G.LFMonitorAdvEdit:GetText() or ""

	if(_G.LFMonitorOptionsCustom:IsVisible())then

		LFM.db.profile.options.basic = bas

		if (bas ~= "") then

			-- make sure magic characters are escaped to preserve literal values
			-- ^$().[]*+-?%
			bas = string.gsub(bas, "[%^%$%(%)%.%[%]%*%+%-%?%%]", "%%%1")

			--strip multiple spaces
			bas = string.gsub(bas, "%s+", " ")
			
		end

		LFM.db.profile.options.basicesc = bas
		LFM.db.profile.options.adv = adv

	end

end

function LFMonitor:FontSliderOnValueChanged(self)

	local slider = self:GetName()

	LFM.db.profile.alert.font.height = self:GetValue()
	LFMonitor:SetAlertFont()
	_G[slider .. "Text"]:SetText(LFM.db.profile.alert.font.height)

end

local function LFMonitor_Sound_DD_Initialise()

	local info

	for sound = 1, #LFMonitor.sounds do
		
		info = {}
		info.text = LFMonitor.sounds[sound].name
		info.value = sound
		info.func = LFMonitor_Sound_DD_OnClick
		UIDropDownMenu_AddButton(info)

	end

end
]]--

local function CreateMainPanel()

	local frame = CreateFrame("Frame", "LFMonitorOptionsMain")
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local version = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local author = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")

	title:SetText("LFMonitor")
	title:SetPoint("CENTER", frame, "CENTER", 0, 170)	

	version:SetText(_G.GAME_VERSION_LABEL .. " " .. GetAddOnMetadata("LFMonitor", "Version"))
	version:SetPoint("CENTER", frame, "CENTER", 0, 140)

	author:SetText("Author: Deepac")
	author:SetPoint("CENTER", frame, "CENTER", 0, 110)

	return frame

end

--[[
local function CreateProfessionPanel()

	local frame = CreateFrame("Frame", "LFMonitorOptionsProfession")
	local alccheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local bscheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local enccheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local engcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local inscheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local jccheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local lwcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local tlrcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local misccheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local lfcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local wtbcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local alctext = alccheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local bstext = bscheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local enctext = enccheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local engtext = engcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local instext = inscheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local jctext = jccheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lwtext = lwcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local tlrtext = tlrcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local misctext = misccheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lftext = lfcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local wtbtext = wtbcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local wtscheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local wtstext = wtscheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lfwcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local lfwtext = wtscheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")

	local function ProfessionOnShow()

		alccheck:SetChecked(LFM.db.char.professions.alc)
		bscheck:SetChecked(LFM.db.char.professions.bs)
		enccheck:SetChecked(LFM.db.char.professions.enc)
		engcheck:SetChecked(LFM.db.char.professions.eng)
		inscheck:SetChecked(LFM.db.char.professions.ins)
		jccheck:SetChecked(LFM.db.char.professions.jc)
		lwcheck:SetChecked(LFM.db.char.professions.lw)
		tlrcheck:SetChecked(LFM.db.char.professions.tlr)
		misccheck:SetChecked(LFM.db.char.monitoring.misc)
		lfcheck:SetChecked(LFM.db.char.monitoring.lf)
		wtbcheck:SetChecked(LFM.db.char.monitoring.wtb)
		wtscheck:SetChecked(LFM.db.char.monitoring.wts)
		lfwcheck:SetChecked(LFM.db.char.monitoring.lfw)

	end

	frame:SetScript("OnShow", ProfessionOnShow)

	title:SetWidth(400)
	title:SetJustifyH("CENTER")
	title:SetText(L["Set the 'Looking For' professions to monitor"])
	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)

	alccheck:SetPoint("LEFT", title, "TOPLEFT", 15, -40)
	alccheck:SetScript("OnClick", function() LFM.db.char.professions.alc = alccheck:GetChecked() end)
	alctext:SetText(LFMonitor.ALCHEMY)
	alctext:SetPoint("LEFT", alccheck, "RIGHT")
	alctext:SetTextColor(1, 1, 1, 1)

	bscheck:SetPoint("LEFT", alccheck, "TOPLEFT", 0, -40)
	bscheck:SetScript("OnClick", function() LFM.db.char.professions.bs = bscheck:GetChecked() end)
	bstext:SetText(LFMonitor.BLACKSMITHING)
	bstext:SetPoint("LEFT", bscheck, "RIGHT")
	bstext:SetTextColor(1, 1, 1, 1)

	enccheck:SetPoint("LEFT", bscheck, "TOPLEFT", 0, -40)
	enccheck:SetScript("OnClick", function() LFM.db.char.professions.enc = enccheck:GetChecked() end)
	enctext:SetText(LFMonitor.ENCHANTING)
	enctext:SetPoint("LEFT", enccheck, "RIGHT")
	enctext:SetTextColor(1, 1, 1, 1)

	engcheck:SetPoint("LEFT", enccheck, "TOPLEFT", 0, -40)
	engcheck:SetScript("OnClick", function() LFM.db.char.professions.eng = engcheck:GetChecked() end)
	engtext:SetText(LFMonitor.ENGINEERING)
	engtext:SetPoint("LEFT", engcheck, "RIGHT")
	engtext:SetTextColor(1, 1, 1, 1)

	inscheck:SetPoint("LEFT", engcheck, "TOPLEFT", 0, -40)
	inscheck:SetScript("OnClick", function() LFM.db.char.professions.ins = inscheck:GetChecked() end)
	instext:SetText(LFMonitor.INSCRIPTION)
	instext:SetPoint("LEFT", inscheck, "RIGHT")
	instext:SetTextColor(1, 1, 1, 1)
	
	jccheck:SetPoint("LEFT", inscheck, "TOPLEFT", 0, -40)
	jccheck:SetScript("OnClick", function() LFM.db.char.professions.jc = jccheck:GetChecked() end)
	jctext:SetText(LFMonitor.JEWELCRAFTING)
	jctext:SetPoint("LEFT", jccheck, "RIGHT")
	jctext:SetTextColor(1, 1, 1, 1)
	
	lwcheck:SetPoint("LEFT", jccheck, "TOPLEFT", 0, -40)
	lwcheck:SetScript("OnClick", function() LFM.db.char.professions.lw = lwcheck:GetChecked() end)
	lwtext:SetText(LFMonitor.LEATHERWORKING)
	lwtext:SetPoint("LEFT", lwcheck, "RIGHT")
	lwtext:SetTextColor(1, 1, 1, 1)
	
	tlrcheck:SetPoint("LEFT", lwcheck, "TOPLEFT", 0, -40)
	tlrcheck:SetScript("OnClick", function() LFM.db.char.professions.tlr = tlrcheck:GetChecked() end)
	tlrtext:SetText(LFMonitor.TAILORING)
	tlrtext:SetPoint("LEFT", tlrcheck, "RIGHT")
	tlrtext:SetTextColor(1, 1, 1, 1)
	
	misccheck:SetPoint("LEFT", tlrcheck, "TOPLEFT", 0, -40)
	misccheck:SetScript("OnClick", function() LFM.db.char.monitoring.misc = misccheck:GetChecked() end)
	misctext:SetText(LFMonitor.ALL_LF_CRAFTER_REQUESTS)
	misctext:SetPoint("LEFT", misccheck, "RIGHT")
	misctext:SetTextColor(1, 1, 1, 1)
	
	lfcheck:SetPoint("LEFT", misccheck, "TOPLEFT", 0, -40)
	lfcheck:SetScript("OnClick", function() LFM.db.char.monitoring.lf = lfcheck:GetChecked() end)
	lftext:SetText(LFMonitor.GENERAL_LF_REQUESTS)
	lftext:SetPoint("LEFT", lfcheck, "RIGHT")
	lftext:SetTextColor(1, 1, 1, 1)
	
	wtbcheck:SetPoint("LEFT", lfcheck, "TOPLEFT", 0, -40)
	wtbcheck:SetScript("OnClick", function() LFM.db.char.monitoring.wtb = wtbcheck:GetChecked() end)
	wtbtext:SetText(LFMonitor.ALL_WTB_REQUESTS)
	wtbtext:SetPoint("LEFT", wtbcheck, "RIGHT")
	wtbtext:SetTextColor(1, 1, 1, 1)

	wtscheck:SetPoint("LEFT", wtbcheck, "TOPLEFT", 0, -40)
	wtscheck:SetScript("OnClick", function() LFM.db.char.monitoring.wts = wtscheck:GetChecked() end)
	wtstext:SetText(LFMonitor.ALL_WTS_REQUESTS)
	wtstext:SetPoint("LEFT", wtscheck, "RIGHT")
	wtstext:SetTextColor(1, 1, 1 ,1)

	lfwcheck:SetPoint("LEFT", wtscheck, "TOPLEFT", 0, -40)
	lfwcheck:SetScript("OnClick", function() LFM.db.char.monitoring.lfw = lfwcheck:GetChecked() end)
	lfwtext:SetText(LFMonitor.ALL_LFW_REQUESTS)
	lfwtext:SetPoint("LEFT", lfwcheck, "RIGHT")
	lfwtext:SetTextColor(1, 1, 1 ,1)

	return frame

end

]]--

--[[
local function CreateAppearancePanel()

	local frame = CreateFrame("Frame", "LFMonitorOptionsAppearance")
	local slider = CreateFrame("Slider", "LFMonitorFontSlider", frame, "OptionsSliderTemplate")
	local tscolour, tsback = LFMonitor:CreateColourBox(frame)
	local pncolour, pnback = LFMonitor:CreateColourBox(frame)
	local mtcolour, mtback = LFMonitor:CreateColourBox(frame)
	local wincolour, winback = LFMonitor:CreateColourBox(frame)
	local borcolour, borback = LFMonitor:CreateColourBox(frame)
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local texttitle = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local wintitle = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local fonttitle = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local tstitle = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local tstext = tscolour:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local pntext = pncolour:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local mttext = mtcolour:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local wintext = wincolour:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local bortext = borcolour:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local fontselect, fontselected = LFMonitor:CreateComboBox(frame, "LFMonitorFontSelect")
	local tsselect, tsselected = LFMonitor:CreateComboBox(frame, "LFMonitorTSSelect")
	local classcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local classtext = classcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")

	local function frameOnShow()

		classcheck:SetChecked(LFM.db.profile.options.useclasscolours)

	end

	frame:SetScript("OnShow", frameOnShow)

	title:SetWidth(400)
	title:SetText(L["Appearance options"])
	title:SetJustifyH("CENTER")
	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)

	texttitle:SetWidth(400)
	texttitle:SetText(L["Text"])
	texttitle:SetJustifyH("LEFT")
	texttitle:SetPoint("LEFT", title, "TOPLEFT", 42, -40)

	wintitle:SetWidth(400)
	wintitle:SetText(L["Window"])
	wintitle:SetJustifyH("LEFT")
	wintitle:SetPoint("LEFT", texttitle, "TOPLEFT", 0, -150)

	fonttitle:SetText(L["Font"])
	fonttitle:SetJustifyH("LEFT")
	fonttitle:SetPoint("TOPLEFT", texttitle, "TOPLEFT", 200, 0)

	tstitle:SetWidth(400)
	tstitle:SetText(L["Timestamp format"])
	tstitle:SetJustifyH("CENTER")
	tstitle:SetPoint("TOPLEFT", frame, 5, -270)

	tscolour:SetPoint("LEFT", texttitle, "TOPLEFT", -27, -35)
	tscolour:SetScript("OnShow", function() SetSelectColour(tsback, "timestamp") end)
	tscolour:SetScript("OnMouseDown", function(self, arg1) if (arg1 == "LeftButton") then OptAppClick(tsback, "timestamp") end end)

	tstext:SetPoint("LEFT", tscolour, "RIGHT", 10, 0)
	tstext:SetTextColor(1, 1, 1, 1)
	tstext:SetText(L["Timestamp"])

	pncolour:SetPoint("LEFT", tscolour, "TOPLEFT", 0, -30)
	pncolour:SetScript("OnShow", function() SetSelectColour(pnback, "player") end)
	pncolour:SetScript("OnMouseDown", function(self, arg1) if (arg1 == "LeftButton") then OptAppClick(pnback, "player") end end)

	pntext:SetPoint("LEFT", pncolour, "RIGHT", 10, 0)
	pntext:SetTextColor(1, 1, 1, 1)
	pntext:SetText(_G.CALENDAR_PLAYER_NAME)

	mtcolour:SetPoint("LEFT", pncolour, "TOPLEFT", 0, -30)
	mtcolour:SetScript("OnShow", function() SetSelectColour(mtback, "text") end)
	mtcolour:SetScript("OnMouseDown", function(self, arg1) if (arg1 == "LeftButton") then OptAppClick(mtback, "text") end end)

	mttext:SetPoint("LEFT", mtcolour, "RIGHT", 10, 0)
	mttext:SetTextColor(1, 1, 1, 1)
	mttext:SetText(L["Message text"])

	classcheck:SetPoint("LEFT", mtcolour, "TOPLEFT", -4, -45)
	classcheck:SetScript("OnClick", function() LFM.db.profile.options.useclasscolours = classcheck:GetChecked() or 0 end)
	classtext:SetPoint("LEFT", classcheck, "RIGHT", 4, 0)
	classtext:SetTextColor(1, 1, 1, 1)
	classtext:SetText(L["Use class colours"])

	wincolour:SetPoint("LEFT", wintitle, "TOPLEFT", -27, -35)
	wincolour:SetScript("OnShow", function() SetSelectColour(winback, "background") end)
	wincolour:SetScript("OnMouseDown", function(self, arg1) if (arg1 == "LeftButton") then OptAppClick(mtback, "background") end end)

	wintext:SetPoint("LEFT", wincolour, "RIGHT", 10, 0)
	wintext:SetTextColor(1, 1, 1, 1)
	wintext:SetText(L["Window"])

	borcolour:SetPoint("LEFT", wincolour, "TOPLEFT", 0, -30)
	borcolour:SetScript("OnShow", function() SetSelectColour(borback, "border") end)
	borcolour:SetScript("OnMouseDown", function(self, arg1) if (arg1 == "LeftButton") then OptAppClick(borback, "border") end end)

	bortext:SetPoint("LEFT", borcolour, "RIGHT", 10, 0)
	bortext:SetTextColor(1, 1, 1, 1)
	bortext:SetText(_G.EMBLEM_BORDER)

	local function fontOnShow()

		fontselected:SetText(LFMonitor.fonts[LFM.db.profile.alert.font.index].name)
		UIDropDownMenu_Initialize(fontselect, LFMonitor_Font_DD_Initialise)

	end
	
	fontselect:SetPoint("CENTER", fonttitle, "CENTER", 0, -30)
	fontselect:SetScript("OnShow", fontOnShow)

	slider:SetPoint("CENTER", fontselect, "CENTER", 0, -40)
	slider:SetMinMaxValues(6, 18)
	slider:SetValueStep(1)

	local function sliderOnShow()

		slider:SetValue(LFM.db.profile.alert.font.height)
		LFMonitorFontSliderLow:SetText(6)
		LFMonitorFontSliderHigh:SetText(18)
		LFMonitorFontSliderText:SetText(LFM.db.profile.alert.font.height)

	end

	slider:SetScript("OnShow", sliderOnShow)

	local function sliderOnValueChanged()

		LFM.db.profile.alert.font.height = slider:GetValue()
		LFMonitor:SetAlertFont()
		LFMonitorFontSliderText:SetText(LFM.db.profile.alert.font.height)

	end

	slider:SetScript("OnValueChanged", sliderOnValueChanged)

	local function tsOnShow()

		tsselected:SetText(LFMonitor.timestamps[LFM.db.profile.options.timestamp].name)
		UIDropDownMenu_Initialize(tsselect, LFMonitor_TS_DD_Initialise)

	end
	
	tsselect:SetPoint("CENTER", tstitle, "CENTER", 0, -35)
	tsselect:SetScript("OnShow", tsOnShow)                    

	return frame

end
]]--

--[[
local function CreateGeneralPanel()

	local frame = CreateFrame("Frame", "LFMonitorOptionsAppearance")
	local discheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local lockcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local showframe = CreateFrame("Frame", nil, frame)
	local restcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local tradecheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local combcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local instcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local soundcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local generalcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local tradechancheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local guildcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local lfgcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local showtex = showframe:CreateTexture()
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local channels = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local distext = discheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local cltext = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local locktext = lockcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local resttext = restcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local tradetext = restcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local combtext = combcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local insttext = instcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local soundtext = soundcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local generaltext = generalcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local tradechantext = tradecheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local guildtext = guildcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lfgtext = guildcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local soundselect, soundselected = LFMonitor:CreateComboBox(frame, "LFMonitorSoundSelect")

	local function GeneralOnShow()

		discheck:SetChecked(LFM.db.profile.options.disabled)
		lockcheck:SetChecked(LFM.db.profile.options.locked)
		instcheck:SetChecked(LFM.db.profile.options.hinst)
		restcheck:SetChecked(LFM.db.profile.options.rested)
		tradecheck:SetChecked(LFM.db.profile.options.trade)
		combcheck:SetChecked(LFM.db.profile.options.combat)
		soundcheck:SetChecked(LFM.db.profile.options.soundon)
		generalcheck:SetChecked(LFM.db.char.channels.general)
		tradechancheck:SetChecked(LFM.db.char.channels.trade)
		guildcheck:SetChecked(LFM.db.char.channels.guild)
		lfgcheck:SetChecked(LFM.db.char.channels.lfg)

		if (soundcheck:GetChecked()) then

			soundselect:Show()

		else

			soundselect:Hide()

		end

	end

	frame:SetScript("OnShow", GeneralOnShow)

	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)
	title:SetJustifyH("CENTER")
	title:SetWidth(400)
	title:SetText(L["General options"])

	channels:SetPoint("TOPLEFT", title, "TOPLEFT", 42, -240)
	channels:SetWidth(400)
	channels:SetJustifyH("CENTER")
	channels:SetText(L["Monitored channels"])

	showframe:SetPoint("TOPLEFT", title, "TOPLEFT", 6, -22)
	showframe:SetHeight(62)
	showframe:SetWidth(390)
	showframe:SetBackdrop({edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16})
	showframe:SetBackdropBorderColor(0.6, 0.6, 0.6, 0.6)
	showtex:SetAllPoints(showframe)

	local function radioOnClick(chk1, chk2)

		if ((chk1:GetChecked()) and (chk2:GetChecked())) then

			chk2:SetChecked(0)

		end

		LFM.db.profile.options.rested = restcheck:GetChecked()
		LFM.db.profile.options.trade = tradecheck:GetChecked()
		LFMonitor:DisableCheck()

	end
		
	restcheck:SetPoint("LEFT", title, "TOPLEFT", 15, -40)
	restcheck:SetScript("OnClick", function() radioOnClick(restcheck, tradecheck) end)

	resttext:SetPoint("LEFT", restcheck, "RIGHT")
	resttext:SetTextColor(1, 1, 1, 1)
	resttext:SetText(L["Only show in rest zones"])

	tradecheck:SetPoint("LEFT", restcheck, "TOPLEFT", 0, -40)
	tradecheck:SetScript("OnClick", function() radioOnClick(tradecheck, restcheck) end)

	tradetext:SetPoint("LEFT", tradecheck, "RIGHT")
	tradetext:SetTextColor(1, 1, 1, 1)
	tradetext:SetText(L["Only show when in Trade channel"])

	discheck:SetPoint("LEFT", tradecheck, "TOPLEFT", 0, -45)
	discheck:SetScript("OnClick", function() LFM.db.profile.options.disabled = discheck:GetChecked(); LFMonitor:DisableCheck(discheck:GetChecked()) end)

	distext:SetPoint("LEFT", discheck, "RIGHT")
	distext:SetTextColor(1, 1, 1, 1)
	distext:SetText(_G.ADDON_DISABLED)

	lockcheck:SetPoint("LEFT", discheck, "TOPLEFT", 0, -40)
	lockcheck:SetScript("OnClick", function() LFMonitor:SetLocked(lockcheck:GetChecked()) end)

	locktext:SetPoint("LEFT", lockcheck, "RIGHT")
	locktext:SetTextColor(1, 1, 1, 1)
	locktext:SetText(L["Lock position and size"])

	combcheck:SetPoint("LEFT", lockcheck, "TOPLEFT", 0, -40)
	combcheck:SetScript("OnClick", function() LFM.db.profile.options.combat = combcheck:GetChecked() end)

	combtext:SetPoint("LEFT", combcheck, "RIGHT")
	combtext:SetTextColor(1, 1, 1, 1)
	combtext:SetText(L["Hide in combat"])

	instcheck:SetPoint("LEFT", combcheck, "TOPLEFT", 0, -40)
	instcheck:SetScript("OnClick", function() LFM.db.profile.options.hinst = instcheck:GetChecked(); LFMonitor:DisableCheck(); end)

	insttext:SetPoint("LEFT", instcheck, "RIGHT")
	insttext:SetTextColor(1, 1, 1, 1)
	insttext:SetText(L["Hide in instances"])

	soundcheck:SetPoint("LEFT", instcheck, "TOPLEFT", 0, -40)
	soundcheck:SetScript("OnClick", function() LFM.db.profile.options.soundon = soundcheck:GetChecked(); if (soundcheck:GetChecked()) then soundselect:Show() else soundselect:Hide() end end)

	soundtext:SetPoint("LEFT", soundcheck, "RIGHT")
	soundtext:SetTextColor(1, 1, 1, 1)
	soundtext:SetText(L["Sound on"])

	local function soundOnShow()

		soundselected:SetText(LFMonitor.sounds[LFM.db.profile.options.sound].name)
		UIDropDownMenu_Initialize(soundselect, LFMonitor_Sound_DD_Initialise)

	end
	
	soundselect:SetPoint("LEFT", soundcheck, "RIGHT", 100, -2)
	soundselect:SetScript("OnShow", soundOnShow)

	generalcheck:SetPoint("LEFT", soundcheck, "TOPLEFT", 0, -80)
	generalcheck:SetScript("OnClick", function() LFM.db.char.channels.general = generalcheck:GetChecked() end)
	
	generaltext:SetPoint("LEFT", generalcheck, "RIGHT")
	generaltext:SetTextColor(1, 1, 1, 1)
	generaltext:SetText(_G.GENERAL)

	tradechancheck:SetPoint("LEFT", generalcheck, "TOPLEFT", 0, -40)
	tradechancheck:SetScript("OnClick", function() LFM.db.char.channels.trade = tradechancheck:GetChecked() end)
	
	tradechantext:SetPoint("LEFT", tradechancheck, "RIGHT")
	tradechantext:SetTextColor(1, 1, 1, 1)
	tradechantext:SetText(_G.TRADE)
	
	guildcheck:SetPoint("LEFT", tradechancheck, "TOPLEFT", 0, -40)
	guildcheck:SetScript("OnClick", function() LFM.db.char.channels.guild = guildcheck:GetChecked() end)
	
	guildtext:SetPoint("LEFT", guildcheck, "RIGHT")
	guildtext:SetTextColor(1, 1, 1, 1)
	guildtext:SetText(_G.GUILD)

	lfgcheck:SetPoint("TOPLEFT", generalcheck, "TOPLEFT", 180, 0)
	lfgcheck:SetScript("OnClick", function() LFM.db.char.channels.lfg = lfgcheck:GetChecked() end)

	lfgtext:SetPoint("LEFT", lfgcheck, "RIGHT")
	lfgtext:SetTextColor(1, 1, 1, 1)
	lfgtext:SetText(_G.LFG_TITLE)

	return frame

end
]]--

--[[
local function CreateClassPanel()

	local frame = CreateFrame("Frame", "LFMonitorOptionsAppearance")
	local lfmcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local lfgcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local dkcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local drcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local hucheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local macheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local pacheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local prcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local rocheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local shcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local wacheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local wrcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local override = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local limit = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local lfmtext = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lfgtext = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local dktext = dkcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local drtext = drcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local hutext = hucheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local matext = macheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local patext = pacheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local prtext = prcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local rotext = rocheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local shtext = shcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local watext = wacheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local wrtext = wrcheck:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local overridetext = override:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local txt, num

	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)
	title:SetJustifyH("CENTER")
	title:SetWidth(400)
	title:SetText(LFMonitor.LFM_OPTIONS)

	limit:SetPoint("LEFT", title, "TOPLEFT", 15, -100)
	limit:SetJustifyH("LEFT")
	limit:SetWidth(400)
	limit:SetText(LFMonitor.LFM_LIMIT)

	local function SetLFMOptions(show)

		local checks = {dkcheck, drcheck, hucheck, macheck, pacheck, prcheck, rocheck, shcheck, wacheck, wrcheck, limit}

		if (show == 1) then

			for _, check in ipairs(checks) do

				check:Show()

			end

		else

			for _, check in ipairs(checks) do

				check:Hide()

			end

		end

	end

	lfmcheck:SetPoint("LEFT", title, "TOPLEFT", 15, -40)
	lfmcheck:SetScript("OnClick", function() LFM.db.char.monitoring.lfm = lfmcheck:GetChecked(); SetLFMOptions(lfmcheck:GetChecked()) end)
	
	lfmtext:SetPoint("LEFT", lfmcheck, "RIGHT")
	lfmtext:SetTextColor(1, 1, 1, 1)
	lfmtext:SetText(LFMonitor.ALL_LFM_REQUESTS)

	lfgcheck:SetPoint("LEFT", lfmcheck, "TOPLEFT", 0, -40)
	lfgcheck:SetScript("OnClick", function() LFM.db.char.monitoring.lfg = lfgcheck:GetChecked() end)
	
	lfgtext:SetPoint("LEFT", lfgcheck, "RIGHT")
	lfgtext:SetTextColor(1, 1, 1, 1)
	lfgtext:SetText(LFMonitor.ALL_LFG_REQUESTS)

	dkcheck:SetPoint("LEFT", limit, "TOPLEFT", 0, -40)
	dkcheck:SetScript("OnClick", function() LFM.db.char.classes.dk = dkcheck:GetChecked() end)
	
	dktext:SetPoint("LEFT", dkcheck, "RIGHT")
	dktext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.DK_TXT[1],"(%a)", string.upper, 1)
	dktext:SetText(txt)

	drcheck:SetPoint("LEFT", dkcheck, "TOPLEFT", 0, -35)
	drcheck:SetScript("OnClick", function() LFM.db.char.classes.dr = drcheck:GetChecked() end)
	
	drtext:SetPoint("LEFT", drcheck, "RIGHT")
	drtext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.DR_TXT[1],"(%a)", string.upper, 1)
	drtext:SetText(txt)

	hucheck:SetPoint("LEFT", drcheck, "TOPLEFT", 0, -35)
	hucheck:SetScript("OnClick", function() LFM.db.char.classes.hu = hucheck:GetChecked() end)
	
	hutext:SetPoint("LEFT", hucheck, "RIGHT")
	hutext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.HU_TXT[1],"(%a)", string.upper, 1)
	hutext:SetText(txt)

	macheck:SetPoint("LEFT", hucheck, "TOPLEFT", 0, -35)
	macheck:SetScript("OnClick", function() LFM.db.char.classes.ma = macheck:GetChecked() end)
	
	matext:SetPoint("LEFT", macheck, "RIGHT")
	matext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.MA_TXT[1],"(%a)", string.upper, 1)
	matext:SetText(txt)

	pacheck:SetPoint("LEFT", macheck, "TOPLEFT", 0, -35)
	pacheck:SetScript("OnClick", function() LFM.db.char.classes.pa = pacheck:GetChecked() end)
	
	patext:SetPoint("LEFT", pacheck, "RIGHT")
	patext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.PA_TXT[1],"(%a)", string.upper, 1)
	patext:SetText(txt)

	prcheck:SetPoint("LEFT", pacheck, "TOPLEFT", 0, -35)
	prcheck:SetScript("OnClick", function() LFM.db.char.classes.pr = prcheck:GetChecked() end)
	
	prtext:SetPoint("LEFT", prcheck, "RIGHT")
	prtext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.PR_TXT[1],"(%a)", string.upper, 1)
	prtext:SetText(txt)

	rocheck:SetPoint("LEFT", prcheck, "TOPLEFT", 0, -35)
	rocheck:SetScript("OnClick", function() LFM.db.char.classes.ro = rocheck:GetChecked() end)
	
	rotext:SetPoint("LEFT", rocheck, "RIGHT")
	rotext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.RO_TXT[1],"(%a)", string.upper, 1)
	rotext:SetText(txt)

	shcheck:SetPoint("LEFT", rocheck, "TOPLEFT", 0, -35)
	shcheck:SetScript("OnClick", function() LFM.db.char.classes.sh = shcheck:GetChecked() end)
	
	shtext:SetPoint("LEFT", shcheck, "RIGHT")
	shtext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.SH_TXT[1],"(%a)", string.upper, 1)
	shtext:SetText(txt)

	wacheck:SetPoint("LEFT", shcheck, "TOPLEFT", 0, -35)
	wacheck:SetScript("OnClick", function() LFM.db.char.classes.wa = wacheck:GetChecked() end)
	
	watext:SetPoint("LEFT", wacheck, "RIGHT")
	watext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.WA_TXT[1],"(%a)", string.upper, 1)
	watext:SetText(txt)

	wrcheck:SetPoint("LEFT", wacheck, "TOPLEFT", 0, -35)
	wrcheck:SetScript("OnClick", function() LFM.db.char.classes.wr = wrcheck:GetChecked() end)
	
	wrtext:SetPoint("LEFT", wrcheck, "RIGHT")
	wrtext:SetTextColor(1, 1, 1, 1)
	txt, num = string.gsub(LFMonitor.WR_TXT[1],"(%a)", string.upper, 1)
	wrtext:SetText(txt)

	override:SetPoint("LEFT", wrcheck, "TOPLEFT", 0, -70)
	override:SetScript("OnClick", function() LFM.db.profile.options.overrideraid = override:GetChecked() end)
	
	overridetext:SetPoint("LEFT", override, "RIGHT")
	overridetext:SetTextColor(1, 1, 1, 1)
	overridetext:SetText(LFMonitor.IGNORE_RAID)
	
	local function ClassOnShow()

		lfmcheck:SetChecked(LFM.db.char.monitoring.lfm)
		lfgcheck:SetChecked(LFM.db.char.monitoring.lfg)
		dkcheck:SetChecked(LFM.db.char.classes.dk)
		drcheck:SetChecked(LFM.db.char.classes.dr)
		hucheck:SetChecked(LFM.db.char.classes.hu)
		macheck:SetChecked(LFM.db.char.classes.ma)
		pacheck:SetChecked(LFM.db.char.classes.pa)
		prcheck:SetChecked(LFM.db.char.classes.pr)
		rocheck:SetChecked(LFM.db.char.classes.ro)
		shcheck:SetChecked(LFM.db.char.classes.sh)
		wacheck:SetChecked(LFM.db.char.classes.wa)
		wrcheck:SetChecked(LFM.db.char.classes.wr)
		override:SetChecked(LFM.db.profile.options.overrideraid)
		SetLFMOptions(lfmcheck:GetChecked())

	end

	frame:SetScript("OnShow", ClassOnShow)

	return frame

end
]]--

--[[
local function CreateResponsePanel()

	local frame = CreateFrame("Frame", "LFMonitorOptionsRespond")
	local alcedit = CreateFrame("EditBox", "LFMonitorAlcEdit", frame, "InputBoxTemplate")
	local bsedit = CreateFrame("EditBox", "LFMonitorBsEdit", frame, "InputBoxTemplate")
	local encedit = CreateFrame("EditBox", "LFMonitorEncEdit", frame, "InputBoxTemplate")
	local engedit = CreateFrame("EditBox", "LFMonitorEngEdit", frame, "InputBoxTemplate")
	local insedit = CreateFrame("EditBox", "LFMonitorInsEdit", frame, "InputBoxTemplate")
	local jcedit = CreateFrame("EditBox", "LFMonitorJcEdit", frame, "InputBoxTemplate")
	local lwedit = CreateFrame("EditBox", "LFMonitorLwEdit", frame, "InputBoxTemplate")
	local tlredit = CreateFrame("EditBox", "LFMonitorTlrEdit", frame, "InputBoxTemplate")
	local lfgedit = CreateFrame("EditBox", "LFMonitorLFGEdit", frame, "InputBoxTemplate")
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local alctext = alcedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local bstext = bsedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local enctext = encedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local engtext = engedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local instext = insedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local jctext = jcedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lwtext = lwedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local tlrtext = tlredit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local lfgtext = lfgedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	local edits = {
		{box = alcedit, text = alctext, db = "alc", title = LFMonitor.ALCHEMY},
		{box = bsedit, text = bstext, db = "bs", title = LFMonitor.BLACKSMITHING},
		{box = encedit, text = enctext, db = "enc", title = LFMonitor.ENCHANTING},
		{box = engedit, text = engtext, db = "eng", title = LFMonitor.ENGINEERING},
		{box = insedit, text = instext, db = "ins", title = LFMonitor.INSCRIPTION},
		{box = jcedit, text = jctext, db = "jc", title = LFMonitor.JEWELCRAFTING},
		{box = lwedit, text = lwtext, db = "lw", title = LFMonitor.LEATHERWORKING},
		{box = tlredit, text = tlrtext, db = "tlr", title = LFMonitor.TAILORING},
		}
	local first, anchor = true, title
	local offsety, offsetx = -55, 10

	frame:Hide()

	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)
	title:SetWidth(400)
	title:SetText(L["Responses to 'Looking For' requests"])

	local function responseOnShow()

		for _, edit in ipairs(edits) do

			if ((first) and (LFM.db.char.professions[edit.db] == 1)) then

				anchor = title
				first = nil
				offsetx = 10

			else

				offsetx = 0

			end

			if (LFM.db.char.professions[edit.db] == 1) then

				edit.box:SetPoint("LEFT", anchor, "TOPLEFT", offsetx, offsety)
				edit.box:SetWidth(385)
				edit.box:SetHeight(32)
				edit.box:SetMaxLetters(90)
				edit.box:SetAutoFocus(false)
				edit.box:SetText(LFM.db.char.responses[edit.db])
				edit.box:SetScript("OnEditFocusGained", function(self) LFMonitor.EditFocus = self end)
				edit.box:SetScript("OnEditFocusLost", function() LFMonitor.EditFocus = nil end)
				edit.text:SetPoint("LEFT", edit.box, "TOPLEFT", 0, 5)
				edit.text:SetText(edit.title)
				edit.box:Show()
				anchor = edit.box

			else

				edit.box:Hide()

			end

		end

		if (LFM.db.char.monitoring.lfm == 1) then

			local function lfgMouse(self, button)

				local cursor = self:GetCursorPosition()
				local text = self:GetText()
				local segment = string.sub(text, 1, cursor)
				local link, txt, sp
				local ls, le = string.find(segment, "|c.-|h|r")

				if ((cursor == nil) or (cursor >= string.len(text))) then

					return

				end

				--remove any leading links and find the one we want

				sp = ls or 1

				while (le) do

					segment = string.sub(segment, le +1)
					sp = sp + le
					ls, le = string.find(segment, "|c.-|h|r")

				end

				ls, le = string.find(segment, "|c")

				if (ls) then

					txt = string.match(text, "|c.-|h|r", sp)
					link = string.match(text, "|H(.-)|h", sp)
					SetItemRef(link, txt, button)

				end

			end

			lfgedit:SetPoint("LEFT", anchor, "TOPLEFT", offsetx, offsety)
			lfgedit:SetWidth(385)
			lfgedit:SetHeight(32)
			lfgedit:SetMaxLetters(90)
			lfgedit:SetAutoFocus(false)
			lfgedit:SetScript("OnEditFocusGained", function(self) LFMonitor.EditFocus = self end)
			lfgedit:SetScript("OnEditFocusLost", function() LFMonitor.EditFocus = nil end)
			lfgedit:SetScript("OnMouseUp", lfgMouse)

			if (LFM.db.char.responses.lfm == nil) then

				LFM.db.char.responses.lfm = L["Invite"]

			end

			lfgedit:SetText(LFM.db.char.responses.lfm)
			lfgtext:SetPoint("LEFT", lfgedit, "TOPLEFT", 0, 5)
			lfgtext:SetText(_G.LFG_TITLE)
			lfgedit:Show()

		else

			lfgedit:Hide()

		end

		first = true

	end

	local function responseOnHide()

		for _, edit in ipairs(edits) do

			edit.box:ClearAllPoints()
			edit.text:ClearAllPoints()

		end

	end

	frame:SetScript("OnShow", responseOnShow)
	frame:SetScript("OnHide", responseOnHide)

	return frame

end
]]--

--local function CreateCustomPanel()

--	local frame = CreateFrame("Frame", "LFMonitorOptionsCustom")
--	local basicedit = CreateFrame("EditBox", "LFMonitorBasicEdit", frame, "InputBoxTemplate")
--	local advedit = CreateFrame("EditBox", "LFMonitorAdvEdit", frame, "InputBoxTemplate")
--	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
--	local basictext = basicedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	local advtext = advedit:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	local inst = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	local warn = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cchantext = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
--	LFMonitor.cc1 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc1text = LFMonitor.cc1:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cc2 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc2text = LFMonitor.cc2:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cc3 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc3text = LFMonitor.cc3:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cc4 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc4text = LFMonitor.cc4:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cc5 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc5text = LFMonitor.cc5:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cc6 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc6text = LFMonitor.cc6:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	LFMonitor.cc7 = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
--	LFMonitor.cc7text = LFMonitor.cc7:CreateFontString(nil, "ARTWORK", "GameFontNormal")
--	local ctl

--	local function customOnShow()

--		local i, v
--		local channels = {GetChannelList()}

--		v = 1

--		for i = 1, 7 do

--			LFMonitor["cc" .. i]:Hide()

--		end

--		for i = 1, #channels, 2 do

--			if (channels[i] > 4) then

--				LFMonitor["cc" .. v .. "text"]:SetText(channels[i + 1])
--				LFMonitor["cc" .. v]:SetChecked(LFM.db.char.channels["cc" .. channels[i + 1]])
--				LFMonitor["cc" .. v]:Show()
--				v = v + 1

--			end

--		end

--		if (v == 1) then

--			LFMonitor.cchantext:Hide()

--		else

--			LFMonitor.cchantext:Show()

--		end

--	end

--	frame:Hide()
--	frame:SetScript("OnShow", customOnShow)

--	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)
--	title:SetWidth(400)
--	title:SetText(LFMonitor.CUSTOM_OPTIONS)

--	inst:SetPoint("TOPLEFT", title, "TOPLEFT", 0, -20)
--	inst:SetWidth(400)
--	inst:SetText(LFMonitor.CUSTOM_INST)

--	basictext:SetPoint("LEFT", inst, "TOPLEFT", 5, -30)
--	basictext:SetText(LFMonitor.CUSTOM_BASIC)

--	basicedit:SetPoint("LEFT", basictext, "TOPLEFT", 5, -25)
--	basicedit:SetWidth(385)
--	basicedit:SetHeight(32)
--	basicedit:SetMaxLetters(90)
--	basicedit:SetAutoFocus(false)
--	basicedit:SetText(LFM.db.profile.options.basic or "")
	
--	warn:SetPoint("TOPLEFT", basicedit, "TOPLEFT", -5, -45)
--	warn:SetTextColor(1, 1, 1, 1)
--	warn:SetWidth(390)
--	warn:SetJustifyH("LEFT")
--	warn:SetText(LFMonitor.CUSTOM_WARNING)

--	advtext:SetPoint("LEFT", warn, "BOTTOMLEFT", 0, -20)
--	advtext:SetText(LFMonitor.CUSTOM_ADV)

--	advedit:SetPoint("LEFT", advtext, "TOPLEFT", 5, -25)
--	advedit:SetWidth(385)
--	advedit:SetHeight(32)
--	advedit:SetMaxLetters(90)
--	advedit:SetAutoFocus(false)
--	advedit:SetText(LFM.db.profile.options.adv or "")

--	LFMonitor.cchantext:SetPoint("TOPLEFT", advedit, "TOPLEFT", 0, -35)
--	LFMonitor.cchantext:SetWidth(400)
--	LFMonitor.cchantext:SetText(LFMonitor.CUSTOM_CHANNELS)

--	local function ctlOnClick(idx)

--		LFM.db.char.channels["cc" .. LFMonitor["cc" .. idx .. "text"]:GetText()] = LFMonitor["cc" .. idx]:GetChecked()

--	end

--	for ctl = 1,7 do

--		if (ctl == 1) then

--			LFMonitor["cc1"]:SetPoint("TOPLEFT", LFMonitor.cchantext, "BOTTOMLEFT", 5, -5)

--		else

--			LFMonitor["cc" .. ctl]:SetPoint("TOPLEFT", LFMonitor["cc" .. (ctl - 1)], "BOTTOMLEFT", 0, 0)

--		end

--		LFMonitor["cc" .. ctl .. "text"]:SetPoint("TOPLEFT", LFMonitor["cc" .. ctl], "TOPRIGHT", 5, -5)
--		LFMonitor["cc" .. ctl]:SetScript("OnClick", function() ctlOnClick(ctl) end)

--	end

--	return frame

--end

--[[
local function GetRaidColour(rlevel)
	
	local colour = GetQuestDifficultyColor(rlevel)
	local rcolour = format("|c%02X%02X%02X%02X", 255, colour.r * 255, colour.g * 255, colour.b * 255);
	
	return rcolour	
	
end
]]--

--[[
function LFMonitor:updateRaidsScroll(numToDisplay, frame)

	local valueStep = 16
	local line, linePlusOffset, fLine
	local numItems, rname, rlevel, rcolour
	local raidname, raidcheck
	
	numItems = table.getn(LFMonitor.RAIDS)
	
	FauxScrollFrame_Update(frame, numItems, numToDisplay, valueStep)
	
	if (numItems == 0) then
	
		for line = 1, numToDisplay do
		
			fLine = _G["LFMR_" .. line]
			fline:Hide()
			
		end
		
	else
	
		for line = 1, numToDisplay do
		
			linePlusOffset = line + FauxScrollFrame_GetOffset(frame)
			fLine = _G["LFMR_" .. line]
			
			if (linePlusOffset <= numItems) then
			
				rname = LFMonitor.RAIDS[linePlusOffset].rname
				rlevel = LFMonitor.RAIDS[linePlusOffset].level
				rcolour = GetRaidColour(rlevel)
				raidname = _G["LFMR_" .. line .. "_raidname"]
				raidcheck = raidname:GetParent()
				
				raidname:SetText(rcolour .. rname)
				raidcheck:SetText(rname)
				raidcheck:SetScript("OnClick", function(self) LFM.db.char.raids[self:GetText()] = self:GetChecked() end)
				raidcheck:SetChecked(LFM.db.char.raids[rname])
				fLine:Show()
				
			else
			
				fLine:Hide()
				
			end
			
		end
		
	end

end
]]--

--[[
function LFMonitor:createLine(parent, linename)

	local frame = CreateFrame("Frame", linename, parent)
	local raidcheck = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
	local raidname = raidcheck:CreateFontString("$parent_raidname", "ARTWORK", "GameFontNormal")
	
	frame:SetHeight(16)
	frame:SetWidth(400)

	raidcheck:SetPoint("LEFT", frame, "LEFT")
	raidcheck:Show()
	
	raidname:SetPoint("LEFT", raidcheck, "RIGHT", 5, 0)
	raidname:Show()
	
	return frame
	
end
]]--

--[[
function LFMonitor:placeLines(frame, lines)

	local c, tmp, ypos
	
	ypos= -55
	
	for c = 1, lines do
	
		tmp = LFMonitor:createLine(frame, "LFMR_" .. c)
		tmp:SetPoint("TOPLEFT", frame, "TOPLEFT", 10, ypos)
		ypos = ypos - 20
		
	end
	
end

function LFMonitor:raidScrollFunction(parent, lines)

	LFMonitor:updateRaidsScroll(lines, parent)
	
end

]]--

--[[
function LFMonitor:createRaidScrollFrame(parent, name)

	local frame = CreateFrame("ScrollFrame", name, parent, "FauxScrollFrameTemplate")
	local itemHeight = 16
	local lines = 18
	
	frame:SetScript("OnVerticalScroll", function(self, offset)
		FauxScrollFrame_OnVerticalScroll(self, offset, itemHeight, 
		function() LFMonitor:raidScrollFunction(frame, lines) end) end)
	frame:EnableMouseWheel(true)
	frame:SetScript("OnMouseWheel", ScrollFrameTemplate_OnMouseWheel)
	
	return frame
	
end
]]--

--[[
local function CreateScrollingRaidPanel()

	local frame = CreateFrame("Frame", "LFMonitorScrollingRaidFrame")
	local sframe = LFMonitor:createRaidScrollFrame(frame, "LFMonitorRaidScrollFrame")
	local lines = 18
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	
	frame:EnableMouse(true)
	frame:EnableKeyboard(true)
	
	title:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -20)
	title:SetWidth(400)
	title:SetText(LFMonitor.RAIDTITLE)
	
	LFMonitor:placeLines(frame, lines)
	
	local function frameOnShow()
	
		LFMonitor:raidScrollFunction(sframe, lines)
		
	end
	
	frame:SetScript("OnShow", function(self) frameOnShow(self) end)
	sframe:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, -55)
	sframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -30, 8)
	return frame
	
end
]]--

function LFMonitor:CreateOptions()

	local mainPanel = CreateMainPanel()
	local professionPanel = CreateProfessionPanel()
	local responsePanel = CreateResponsePanel()
	local generalPanel = CreateGeneralPanel()
	local appearancePanel = CreateAppearancePanel()
	local classPanel = CreateClassPanel()
	local customPanel = CreateCustomPanel()
	local raidsPanel = CreateScrollingRaidPanel()

	mainPanel.name = "LFMonitor"
	mainPanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(mainPanel)

	appearancePanel.name = _G.APPEARANCE_LABEL
	appearancePanel.parent = "LFMonitor"
	appearancePanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(appearancePanel)

	professionPanel.name = L["Looking for"]
	professionPanel.parent = "LFMonitor"
	professionPanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(professionPanel)
	
	classPanel.name = _G.LFM_TITLE
	classPanel.parent = "LFMonitor"
	classPanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(classPanel)

	raidsPanel.name = _G.LFG_TYPE_RAID
	raidsPanel.parent = "LFMonitor"
	raidsPanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(raidsPanel)
	
	responsePanel.name = L["Responses"]
	responsePanel.parent = "LFMonitor"
	responsePanel.okay = function() LFMonitor:ResponseOptionsOkay() end
	responsePanel.cancel = function() LFMonitor:BuildTables() end
	responsePanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(responsePanel)	

	generalPanel.name = _G.GENERAL
	generalPanel.parent = "LFMonitor"
	generalPanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	InterfaceOptions_AddCategory(generalPanel)

	customPanel.name = LFMonitor.CUSTOM_OPTIONS
	customPanel.parent = "LFMonitor"
	customPanel.default = function() StaticPopup_Show("LFMONITOR_DEFAULTS") end
	customPanel.okay = function() LFMonitor:CustomOptionsOkay() end

	InterfaceOptions_AddCategory(customPanel)

end